#ifndef CCONVERTER_HH
#define CCONVERTER_HH

#include "global.hh"

class Cconverter
{
  class Cuser;/* inner class */

public:
  Cconverter();
  ~Cconverter();

private:
  /* input file */
  Cfile* m_file_in;
  /* output file */
  Cfile* m_file_out;

public:
  /* set file */
  int set_file(Cfile* file, std::string mode);
  /* convert rdf file to readable rdf file */
  int convert_binary_to_readable_binary();
  /* convert rdf file to txt file */
  int convert_binary_to_txt();
  /* convert txt file to rdf file */
  int convert_txt_to_binary();

  /* rdf to readable rdf or txt*/
private:
  int read_header_binary(data_t header_block[], Cfile* file);
  int read_event_block_binary(data_t event_block[], Cfile* file);
  int read_ender_binary(data_t ender_block[], Cfile* file);

  int write_header_readable_binary(data_t header_block[], Cfile* file);
  int write_event_block_readable_binary(data_t event_block[], int i, Cfile* file);
  int write_ender_readable_binary(data_t ender_block[], Cfile* file);

  int write_header_txt(data_t header_block[], Cfile* file);
  int write_event_block_txt(data_t event_block[], int i, Cfile* file);
  int write_ender_txt(data_t ender_block[], Cfile* file);

  /* txt to rdf*/
private:
  int read_header_txt(Cuser* header);
  int read_event_block_txt(char buf[], size_t size, Cfile* file);
  int read_ender_txt(Cuser* endder);

  int write_header_binary(Cuser* header);
  int write_event_block_binary(int& event_num);
  int write_ender_binary(Cuser* ender);

  /* header and ennder (for txt to rdf) */
  class Cuser
  {
  public:
    Cuser(){/* nothing */}
    ~Cuser(){/* nothing */}

    char m_run_number[RUN_NUMBER_LEN + 1];
    char m_start_time[START_TIME_LEN + 1];
    char m_stop_time[STOP_TIME_LEN + 1];
    char m_print_time[PRINT_TIME_LEN + 1];
    char m_print_date[PRINT_DATE_LEN + 1];
    char m_header[HEADER_LEN + 1];
    size_t m_header_size;
    char m_ender[ENDER_LEN + 1];
    size_t m_ender_size;
  };
  
  class Cheader : public Cuser{/* nothing */};
  class Cender : public Cuser{/* nothing */};
};

#endif
